---
title: Academic honesty
nav_order: 5
---

Learning cooperatively is different from sharing answers.

You are encouraged to discuss and collaborate on the **lessons** with other students. Working with a study group and discussing your problem solving approach is a particularly effective way to learn. The purpose of each lesson is for you to learn the course material, not to prove that you already know it. Therefore, you can expect to receive substantial assistance from the course staff.

Collaboration is not allowed on **assessments**. You may discuss general ideas of how to approach an assessment, but never specific details about the code to write. Any help you receive from or provide to classmates should be limited and should never involve details of how to code a solution.

Encouraged
: Discussing examples from the lessons. Each lesson is designed to prepare students for assessments.
: Talking to a TA to learn how to solve specific bugs and improve your understanding of the problem.
: Posting questions about problem specifications to the course forum.

Forbidden
: Looking at someone else's assessment solution in any form for any reason at any time, ever.
: Giving or receiving a walkthrough or completed solution for an assessment from anyone else.
: Posting solution code to any assessment in a public place, even after the course is over.

If you are unsure if you are following the policy, ask. There are many resources for helping students learn in this course. Reach out to the course staff for assistance on assessments. Since learning takes time, all assessments can be resubmitted to demonstrate improved mastery. **Instead of turning to forbidden resources, it's a much better idea to submit something not yet complete and revise your work later.**

Regret clause
: If you submit work that is in violation of the academic honesty policy but bring it to the attention of the instructor within 72 hours, you may resubmit your own work without further consequence except in cases of repeated misconduct or abuse.

If you are retaking the course, you may resubmit a previous solution unless that program was involved in an academic misconduct case. If misconduct was found, you must write a new version of that program.
