---
title: Deliberate practice
nav_order: 2
---

Learning computer programming requires **deliberate practice**.

1. Sustained motivation.
1. Tasks that build on prior knowledge.
1. Immediate, personalized feedback on tasks.
1. Repetition of all of the above.

Deliberate practice is about taking on the right challenge with the right support. We'll learn new programming concepts each week in the following manner.

1. Prepare for learning before class by completing the **pre-class preparation**.
1. Collaborate and communicate with others in class through **guided practice**.
1. Master the **checkpoint assessment** (and optional **challenge assessment**).
1. Solve a real problem by mastering the **take-home assessment**.

During the last couple weeks, you'll also work on a **final project** of your team's choosing and produce a **video problem-solving portfolio** that teaches other students how to solve programming problems.

### Learning cooperatively

Collaboration improves the effectiveness of deliberate practice. With the exception of assessments, we encourage you to discuss course activities with your friends and classmates as you are working on them. You will definitely learn more in this class if you work with others than if you do not. If you are helping another student, don't just tell them the answer; they will learn very little and run into trouble on assessments. Instead, try to guide them toward discovering the solution on their own. Practice is most effective when it builds on what we already know; feedback is most helpful when it addresses specific areas for improvement.

In addition to collaborating with other students, the course staff are here to personalized feedback. Your teaching assistant (TA) is your mentor and guide to the course. Your TA can help you get the most out of the class and achieve the highest possible understanding of course concepts.
