---
title: Grading
nav_order: 4
---

Checkpoints, challenges, the final project, and the video problem solving portfolio are all graded on a **Satisfactory (S)** or **Not yet (N)** grading scale. Take-home assessments are graded on the **ESNU** scale.

Exemplary (E)
: Meets all external correctness criteria and all [internal correctness criteria]({{ site.baseurl }}{% link quality/index.md %}).

Satisfactory (S)
: Meets all external correctness criteria but could improve on internal correctness.

Not yet (N)
: Does not meet all external correctness criteria but nonetheless shows some understanding.

Unassessable (U)
: Not enough information to determine whether there is understanding of the concepts.

An important part of learning is revising your work. All take-home assessments can be revised and resubmitted to demonstrate mastery of the learning objectives. While there are no limits on the number of revisions allowed per assessment, each revision counts towards a weekly resubmission limit so it's best to revise and resubmit assessments sooner rather than later.

Take-home assessment submissions
: A best-effort initial submission for each take-home assessment must be made by its Thursday 11:59pm due date [Anywhere on Earth](https://time.is/Anywhere_on_Earth). Up to one (1) additional assessment may be resubmitted each week. Each take-home assessment undergoes code review, which takes one or two weeks to return.

Your final grade in the course is determined by the quality and quantity of work submitted.

4.0
: **S** or better on all 7 take-home assessments, including at least 6 **E**'s.
: **S** on all 6 checkpoints and all 6 challenges.
: **S** on a challenge-level problem solving portfolio.
: **S** on the final project.

3.0
: **S** or better on all 7 take-home assessments, including at least 2 **E**'s.
: **S** on all 6 checkpoints and at least 2 challenges.
: **S** on a checkpoint-level problem solving portfolio.
: **S** on the final project.

2.0
: **S** or better on at least 6 take-home assessments. (No **E**'s required.)
: **S** on all 6 checkpoints. (No challenges required.)
: **S** on a checkpoint-level problem solving portfolio.
: Final project not required.

0.7
: **S** or better on at least 2 take-home assessments.
: **S** on at least 3 checkpoints.
: Problem solving portfolio not required.
: Final project not required.

All criteria for a grade must be met in order to earn that grade. These grade criteria capture the learning objectives in the course, so falling short in any area may result in a lower grade determined at the instructor's discretion.
