---
title: How to succeed
nav_order: 3
---

We want everyone to succeed in this class and learn as much as we can, not only about "course content" but also about ourselves and how we can help the world around us. We've already introduced several meta-learning concepts highlighting the importance of **deliberate practice**, **learning cooperatively**, and **atomic habits**.

Some of these concepts have very practical tips that we can apply to help us in any course.[^1]

[^1]: <https://webster.uaa.washington.edu/asp/website/online-learning/ten-successful-online-study-habits/>

Create a study schedule
: Like eating breakfast or working out at the same time, students who create a study routine and have the discipline to stick to it are able to study information over a longer amount of time instead of staying up late the night before.

Connect with other focused students
: No matter the facet of life, focused and successful people inspire those they're around. Find a study buddy whose work ethic you admire and set up an online review session with them.

Design your study space
: While it may seem counterintuitive to take extra time to clean your room or office before settling down to study, a study by Princeton University found that people who keep their spaces clean are able to process information and focus better.

Ask for help
: If you're studying and realize you don't understand a concept or theory, reach out to your professor or classmates as soon as possible for clarification rather than trying to go it on your own.

Stay mentally and physically healthy
: Online students are likely to spend more time at their computers than traditional learners, making it imperative to take breaks, go on walks, get the recommended amount of sleep, and eat foods that nourish their bodies.

Communication is a key part of our lives now more so than ever, so we ask that you follow these guidelines to ensure everyone has the best experience.

Be especially kind and intentional
: In the online world, our feelings are hard to convey over text and it can be exhausting when we prioritize efficiency. Taking an extra moment to turn on your camera before you speak, personalize your chat messages, and state your intentions out loud goes a long way.

Take space, make space
: Some of us might feel more comfortable sharing our experiences than others. Recognize when we've been taking space in the conversation and turn the stage over to someone who hasn't had a chance to shine yet.

Different situations require different communication
: How we engage in an environment depends on the situation. In group meetings, attention should be paid to the speaker. In brainstorming or coworking sessions, we can be more flexible in how we communicate.
