---
title: Overview
nav_order: 0
---

Computer science is the study of how our ideas can be automated and amplified with computers. Computation is distinctly sociological: computation is defined by humans for humans, so in turn computation defines how we experience life.

In CSE 143, we will learn how to write apps that use data to support everyday life, to answer questions about the world around us, and to make decisions that affect (and oftentimes reinforce) social hierarchies and power structures. By the end of the course, you will be able to:

1. Define externally correct and internally correct programs within larger software systems.
1. Select and apply abstract data types to solve specified problems by managing program state.
1. Compare tradeoffs to select the appropriate implementation for a program or abstract data type.
1. Design and modify data structures capable of insertion, deletion, search, and related operations.
1. Trace through and predict the behavior of programs involving reference data types and recursion.
1. Apply functional decomposition and recursion to break down problems into subproblems.

CSE 143 is organized around 7 applications of computing, a group [project]({{ site.baseurl }}{% link project.md %}) of your own choosing that applies programming with data structures, and a video problem solving portfolio where you teach these programming skills to others.
